package cn.zmofun.eraseapp;

/*
	Copyright zmofun           All rights reserved!
	http://www.zmofun.com
	2000.1.14        TurboC++2.0

  zmofun@163.com
  2020.10.28～10.29    移植到JAVA版本
  2022.3.2 移植到APP版本
*/

import android.app.Activity;
import android.graphics.Point;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.RelativeLayout;
import com.example.tetris.R;

public class MainActivity extends Activity {

    GameBox[] box = new GameBox[1];
    int[] keya = { 87, 83, 65, 68 };// 上下左右w,s,a,d

    Point mScreenSize = new Point(0, 0);
    Point mMousePos = new Point(-1, -1);
    boolean mIsTouchMove = false;
    int mCellSize = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN);
        //requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.activity_main);

        DisplayMetrics dm = this.getApplicationContext().getResources().getDisplayMetrics();
        mScreenSize.x = dm.widthPixels;
        mScreenSize.y = dm.heightPixels;
        mCellSize = (int)(mScreenSize.x / 8);

        box[0] = new GameBox(this);
        box[0].init(205, 150, 50, 16, 30, 80, keya);
        box[0].startGame(true);
        box[0].pauseGame(false);

        setTitle("Erase");
        setVisible(true);

        Button btnLeft = (Button) findViewById(R.id.btnLeft);
        Button btnRight = (Button) findViewById(R.id.btnRight);
        Button btnBottom = (Button) findViewById(R.id.btnBottom);
        Button btnUp = (Button) findViewById(R.id.btnUp);
        View.OnClickListener handler = new View.OnClickListener() {
            public void onClick(View v){
                switch (v.getId()) {
                    case R.id.btnLeft:
                        box[0].play(65);
                        break;
                    case R.id.btnRight:
                        box[0].play(68);
                        break;
                    case R.id.btnBottom:
                        box[0].play(83);
                        break;
                    case R.id.btnUp:
                        box[0].play(87);
                        break;
                }
            }
        };
        btnLeft.setOnClickListener(handler);
        btnRight.setOnClickListener(handler);
        btnBottom.setOnClickListener(handler);
        btnUp.setOnClickListener(handler);

        RelativeLayout layoutCanvas = findViewById(R.id.layoutCanvas);
        layoutCanvas.addView(box[0]);
    }
    public boolean onTouchEvent(MotionEvent event) {
        super.onTouchEvent(event);
        switch( event.getAction() ) {
            case MotionEvent.ACTION_DOWN :
                mIsTouchMove = false;
                if( event.getY() < (int)(mScreenSize.y * 0.75)) {
                    mMousePos.x = (int) event.getX();
                    mMousePos.y = (int) event.getY();
                }
                break;
            case MotionEvent.ACTION_MOVE :
                if( mMousePos.x < 0 )
                    break;
                if( (event.getX() - mMousePos.x) > mCellSize ) {
                    box[0].play(68);  //向右
                    mMousePos.x = (int) event.getX();
                    mMousePos.y = (int) event.getY();
                    mIsTouchMove = true;
                } else if( (mMousePos.x - event.getX()) > mCellSize ) {
                    box[0].play(65); //向左
                    mMousePos.x = (int) event.getX();
                    mMousePos.y = (int) event.getY();
                    mIsTouchMove = true;
                }
                if( (event.getY() - mMousePos.y) > mCellSize ) {
                    box[0].play(83);  //向下
                    mMousePos.x = (int) event.getX();
                    mMousePos.y = (int) event.getY();
                    mIsTouchMove = true;
                } else if( (mMousePos.y - event.getY()) > mCellSize ) {
                    box[0].play(87); //向上
                    mMousePos.x = (int) event.getX();
                    mMousePos.y = (int) event.getY();
                    mIsTouchMove = true;
                }
                break;

            case MotionEvent.ACTION_UP :
                if( mIsTouchMove == false && mMousePos.x > 0 )
                    box[0].play(87);  //向上
                mMousePos.set(-1, -1);
                break;
        }
        return true;
    }

    @Override
    protected void onStop() {
        super.onStop();
        box[0].pauseGame(true);
    }

    @Override
    protected void onRestart() {
        super.onRestart();
        box[0].pauseGame(false);
    }
}
